//XNASprite.cs
//
//XNA Sprite Class
//
//Part of Spengler
//A 2D Platform Engine using XNA
//
//Created 17 February 2007
//
//By Gavin Cox
//
//Copyright  2007 All Rights Reserved

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content;

namespace Spengler
{
	public class XNASprite
	{
		//--- Constants ---


		//--- Variables ---
		protected XNAGraphics xnag;
		protected Texture2D tex;
		public int dir;
		protected int init_dir;
		
		//--- Constructor ---
		public XNASprite(XNAGraphics xnagraphics, String filename)
		{
			xnag = xnagraphics;
			tex = xnagraphics.content.Load<Texture2D>(filename);

			init_dir = Globals.RIGHT;
		}

		//--- Methods ---
		//Draw
		public virtual void Draw(Vector2 position)
		{
			//xnag.spritebatch.Draw(tex, position, Color.White);
			Draw(position, null);
		}

		public virtual void Draw(Vector2 position, Nullable<Rectangle> sourcerect)
		{
			if (dir == init_dir)
			{
				//xnag.spritebatch.Draw(texture, position, sourcerect, Color.White);
				xnag.spritebatch.Draw(texture, position, sourcerect, Color.White, 0, 
										new Vector2(0, 0), 1, SpriteEffects.None, 0);
			}
			else
			{
				xnag.spritebatch.Draw(texture, position, sourcerect, Color.White, 0,
										new Vector2(0, 0), 1, SpriteEffects.FlipHorizontally, 0);
			}
		}

		//- Get Methods -
		//XNAGraphics
		public XNAGraphics xnagraphics
		{
			get
			{
				return xnag;
			}
		}

		//Sprite Batch
		public Texture2D texture
		{
			get
			{
				return tex;
			}
		}

		//Direction
		public int direction
		{
			get
			{
				return dir;
			}

			set
			{
				dir = value;
			}
		}
	}
}
